#include<bits/stdc++.h>
#include <unistd.h>

#define REP(i, n) for(int i = 0; i < n; i++)

using namespace std;

typedef pair<int, int> ii;


int rnd(int a, int b){
	return a + (rand() % (b-a+1));
}



// http://www.concentric.net/~Ttwang/tech/inthash.htm
// Workaround kvuli seedu na srand - proces se spousti mnohokrat za sekundu
unsigned long mix(unsigned long a, unsigned long b, unsigned long c)
{
    a=a-b;  a=a-c;  a=a^(c >> 13);
    b=b-c;  b=b-a;  b=b^(a << 8);
    c=c-a;  c=c-b;  c=c^(b >> 13);
    a=a-b;  a=a-c;  a=a^(c >> 12);
    b=b-c;  b=b-a;  b=b^(a << 16);
    c=c-a;  c=c-b;  c=c^(b >> 5);
    a=a-b;  a=a-c;  a=a^(c >> 3);
    b=b-c;  b=b-a;  b=b^(a << 10);
    c=c-a;  c=c-b;  c=c^(b >> 15);
    return c;
}


void generate_random(int n, int m, set<ii> & res){
	int failcnt = 0;
	while(res.size() < m && failcnt++ < 500000000){
		res.insert({rnd(0,n-1),rnd(0,n-1)});
	}
	assert(failcnt < 500000000);
}


void generate_snake(int n, set<ii> & res){
	int cy = n-1;
	for(int x = 0; x < n;++x){
		for(int y = 0; y < n;++y){
			res.insert({x,y});
		}
		if(++x < n)res.insert({x, cy});
		cy = n-1-cy;
	}
}

void generate_rotated_snake(int n, set<ii> & res){
	set<ii> tmp;
	generate_snake(n, tmp);
	for(auto x : tmp) res.insert({x.second, x.first});
}

void generate_chessboard(int n, set<ii> & res){
	for(int x = 0; x < n; ++x) for(int y = 0; y < n; ++y){
		if((x&1) == (y&1)) res.insert({x,y});
	}
}

void generate_maximaly_sparse(int n, set<ii> & res){
	for(int x = 1; x < n-1; ++x) res.insert({x, rnd(0,n-1)});
}

void remove_column(int n, set<ii> & res, int c){
	for(int y = 0; y < n; ++y) res.erase({c,y});
}

void generate_sparse_long(int n, set<ii> & res){
	for(int x = 0; x < n; ++x) res.insert({x, x&1 ? n-1 : 0});
}

void generate_ell(int n, set<ii> & res){
	int y = 0;
	for(; y < n/3; ++y){
		res.insert({0,y});
	}
	int x = 0;
	for(;x < n;++x) res.insert({x,y});
}

void generate_diagonal(int n, set<ii> & res){
	for(int i = 0; i < n; ++i) res.insert({i, i});
}

void generate_chessboard_and_random(int n, int m, set<ii> & res){
	assert(n > 50 && m > 2500);
	int nn = 0;
	while(((nn)*nn + 1)/2 + 4*(n-nn) < m-2)++nn;
	--nn;
	generate_chessboard(nn, res);
	//cerr << (m - res.size()) << "   " << n << "    " << nn << "    " <<  (m - res.size())/(n-nn)  << endl;
	assert((m - res.size())/(n-nn) >= 4);
	for(;nn < n; ++nn){
		for(int i = 0; i < 4; ++i) res.insert({nn, rnd(0,n-1)});
	}
}

void generate_snake_and_random(int n, int m, set<ii> & res){
	assert(n > 50 && m > 2500);
	int nn = 0;
	while(((nn)*nn + 2*nn)/2 + 4*(n-nn) < m-2)++nn;
	--nn;
	generate_snake(nn, res);
	assert((m - res.size())/(n-nn) >= 4);
	for(;nn < n; ++nn){
		for(int i = 0; i < 4; ++i) res.insert({nn, rnd(0,n-1)});
	}
}

void generate_few_columns(int n, int m, set<ii> & res){
	int nn = 0;
	while((n*nn+1)/2 + n-nn < m-2)++nn;
	--nn;
	for(int x = 0; x < nn; ++x) for(int y = 0; y < n; ++y){
		if((x&1) == (y&1)) res.insert({x,y});
	}
	for(;nn < n; ++nn){
		res.insert({nn, rnd(0,n-1)});
	}
}


int main(int argc, char ** argv){
	

	vector<string> args(argv+1, argv+argc);
	int n = stoi(args[0]);

	unsigned long seed1 = stoi(args[1]);
	unsigned long seed2 = stoi(args[2]);


	unsigned long seed = mix(seed1, 4742, seed2*n);
	//cerr << seed << endl;
	srand(seed);

	set<char> types = {
		'p', //random connected
		'r', //random
		'R', //dtto with removed column
		's', //snake
		'N', //rotated snake
		'c', //chessboard
		'm', //maximally sparse
		'l', //sparse long
		'e', //ell
		'd', //diagonal
		'x', //chessboard and random
		'y', //snake and random
		'f', //few columns
	};

	char type = args[3][0];
	assert(types.find(type) != types.end());

	set<ii> res;
	res.insert({0,0});
	res.insert({n-1,n-1});

	if(type == 'p'){
		int m = stoi(args[4]);
		generate_diagonal(n, res);
		generate_random(n, m, res);
	}
	if(type == 'r'){
		int m = stoi(args[4]);
		generate_random(n, m, res);
	}
	if(type == 'R'){
		int m = stoi(args[4]);
		generate_random(n, m, res);
		remove_column(n, res, n/2);
	}

	if(type == 's')
		generate_snake(n, res);
	if(type == 'N')
		generate_rotated_snake(n, res);
	if(type == 'c'){
		generate_chessboard(n, res);
	}
	if(type == 'm')
		generate_maximaly_sparse(n,res);
	if(type == 'l')
		generate_sparse_long(n,res);
	if(type == 'd')
		generate_diagonal(n,res);
	if(type == 'x'){
		int m = stoi(args[4]);
		generate_chessboard_and_random(n, m, res);
	}
	if(type == 'y'){
		int m = stoi(args[4]);
		generate_snake_and_random(n, m, res);
	}
	if(type == 'f'){
		int m = stoi(args[4]);
		generate_few_columns(n, m, res);
	}


	vector<ii> prnt(res.begin(), res.end());
	random_shuffle(prnt.begin(), prnt.end());

	int mm = prnt.size();
	cout << n << " " << mm << endl;
	for(auto x : prnt){
		cout << x.first+1 << " " << x.second+1 << endl;
	}


} 